// Persistence of Vision Ray Tracer Scene Description File
// File                 : hexmesh.inc
// POV Vers             : 3.1
// Desc                 : Mesh net thing 
// Date                 : 2/25/99
// Auth                 : J Cathcart
// Include version      : 1.1
                        
// You need to use these variables.  You can use them from here if you only need one instance
// But if you need to have more than one, copy them into your source file and #declare them
// just before inserting "#include "mesh.inc".
// The "strands" are each 1 unit long, so increasing the radius higher than that leaves no holes
// in the middle.
//#declare MeshRadius = .05                                              ;
//#declare MeshMaterial = material { texture { pigment { Red } } }       
//#declare MeshXStop = 5                                                     ;
//#declare MeshZStop = 5
//#declare MeshDepth = 45  //degrees       this is to make it bumpy                                                     ;


#declare MeshSection =
union {
  cylinder { <0, 0, 0> <0, 0, 1> MeshRadius   // left |
             rotate x*MeshDepth }
                
  cylinder { <0, 0, 0> <0, 0, 1> MeshRadius   // right |
             translate x*( 2*cos(radians(30))*cos(radians(MeshDepth)) ) 
             rotate x*MeshDepth }
                 
  cylinder { <0, 0, 0> <0, 0, 1> MeshRadius   // lower left \
             rotate <MeshDepth, 120, 0> }  
              
  cylinder { <0, 0, 0> <0, 0, 1> MeshRadius    //upper right \
             rotate <MeshDepth, 120, 0> 
             translate < cos(radians(30))*cos(radians(MeshDepth)) , 0, 1.5*cos(radians(MeshDepth))> }
                          
  cylinder { <0, 0, 0> <0, 0, 1> MeshRadius   //lower right /
             rotate <MeshDepth, 240, 0> 
             translate x*( 2*cos(radians(30))*cos(radians(MeshDepth)) ) }
                              
  cylinder { <0, 0, 0> <0, 0, 1> MeshRadius    //upper left /
             rotate <MeshDepth, 240, 0>
             translate <cos(radians(30))*cos(radians(MeshDepth)), 0, 1.5*cos(radians(MeshDepth))> }
                          
  material { MeshMaterial }
}

//#declare MeshZStart = 0       ;
//#declare MeshXHold = MeshXStart        ;
                                                   //cos(radians(30))
#declare MeshObject =
union {
#while (MeshZStart < MeshZStop)
  #while (MeshXStart < MeshXStop) 
    #if (mod (MeshZStart,2) = 0 ) 
      object { MeshSection
               translate < MeshXStart*( 2*cos(radians(30))*cos(radians(MeshDepth)) ),
                           0, MeshZStart*1.5*cos(radians(MeshDepth)) > }
    #else
      object { MeshSection 
               translate < MeshXStart*( 2*cos(radians(30))*cos(radians(MeshDepth)) ) + ( cos(radians(30))*cos(radians(MeshDepth)) ) ,
                           0, MeshZStart*1.5*cos(radians(MeshDepth)) > }
    #end
    #declare MeshXStart=MeshXStart + 1  
  #end
  #declare MeshXStart = MeshXHold
  #declare MeshZStart = MeshZStart + 1  
#end           
}